View Issue Details

IDProjectCategoryView StatusLast Update
0000225Pgpool-IIBugpublic2016-09-09 14:42
Reporterd.vasilyev@postgrespro.ruAssigned Tot-ishii 
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionopen 
PlatformLinux x86_64OSUbuntuOS Version16.04
Product Version3.2.15 
Target Version3.2.17Fixed in Version 
Summary0000225: pgpool segfault
DescriptionAttached link with 0000014:0000030 unexpected coredumps and binary files: https://oc.postgrespro.ru/index.php/s/0xCSluax0sl6DZE

#/usr/local/bin/pgpool --version
pgpool-II version 3.2.15 (namameboshi)
TagsNo tags attached.

Activities

t-ishii

2016-07-27 08:41

developer   ~0000943

Last edited: 2016-07-27 13:03

View 2 revisions

Thanks for the report. I was able to reproduce the problem using the pgpool binary and core file uploaded to the URL (for developers convenience, I uploaded the core file and the binary extracted from the compressed archive.

It seems the bug was triggered when DB node 0 is disconnected (down status).
Will fix.

(gdb) bt
#0 0x000000000041686e in pool_send_frontend_exits (backend=backend@entry=0x1fe77d0)
    at pool_process_query.c:995
0000001 0x000000000040c1ed in do_child (unix_fd=unix_fd@entry=5, inet_fd=inet_fd@entry=6) at child.c:423
0000002 0x00000000004075a1 in fork_a_child (unix_fd=5, inet_fd=6, id=349) at main.c:1271
0000003 0x0000000000407c27 in reaper () at main.c:2426
0000004 0x000000000040851d in pool_sleep (second=<optimized out>) at main.c:2623
0000005 0x0000000000406001 in main (argc=<optimized out>, argv=<optimized out>) at main.c:837
(gdb) list
990 */
991 if (VALID_BACKEND(i) && CONNECTION_SLOT(backend, i))
992 {
993 pool_write(CONNECTION(backend, i), "X", 1);
994
995 if (MAJOR(backend) == PROTO_MAJOR_V3)
996 {
997 len = htonl(4);
998 pool_write(CONNECTION(backend, i), &len, sizeof(len));
999 }

t-ishii

2016-07-27 10:59

developer  

core.pgpool.0.e4e576b822364c8a9ecddf21d02d02c3.26943.1469522736000000000000 (14,331,904 bytes)

t-ishii

2016-07-27 10:59

developer  

pgpool (4,084,608 bytes)

t-ishii

2016-07-27 17:05

developer   ~0000944

I have committed fix from master to 3.1 branches. Please try if you like.

d.vasilyev@postgrespro.ru

2016-07-27 18:39

reporter   ~0000945

Thank you! We will try.

t-ishii

2016-09-06 17:54

developer   ~0001056

Any progress on this?

t-ishii

2016-09-09 14:42

developer   ~0001061

No feedback for over one month. Issue closed.

Issue History

Date Modified Username Field Change
2016-07-27 01:18 d.vasilyev@postgrespro.ru New Issue
2016-07-27 08:41 t-ishii Assigned To => t-ishii
2016-07-27 08:41 t-ishii Status new => assigned
2016-07-27 08:41 t-ishii Note Added: 0000943
2016-07-27 10:59 t-ishii File Added: core.pgpool.0.e4e576b822364c8a9ecddf21d02d02c3.26943.1469522736000000000000
2016-07-27 10:59 t-ishii File Added: pgpool
2016-07-27 13:03 t-ishii Note Edited: 0000943 View Revisions
2016-07-27 17:05 t-ishii Note Added: 0000944
2016-07-27 17:05 t-ishii Status assigned => feedback
2016-07-27 18:11 administrator Product Version => 3.2.15
2016-07-27 18:11 administrator Target Version => 3.2.17
2016-07-27 18:39 d.vasilyev@postgrespro.ru Note Added: 0000945
2016-07-27 18:39 d.vasilyev@postgrespro.ru Status feedback => assigned
2016-07-31 08:53 administrator Status assigned => feedback
2016-09-06 17:54 t-ishii Note Added: 0001056
2016-09-09 14:42 t-ishii Note Added: 0001061
2016-09-09 14:42 t-ishii Status feedback => closed